package jp.agentec.sinaburocast.form.user;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

import jp.agentec.sinaburocast.common.SinaburoConstant;
import jp.agentec.sinaburocast.entity.Answer;
import jp.agentec.sinaburocast.entity.Enquete;
import jp.agentec.sinaburocast.entity.Member;
import jp.agentec.sinaburocast.entity.Organization;
import jp.agentec.sinaburocast.entity.Question;
import jp.agentec.sinaburocast.entity.Template;

import org.apache.commons.lang.builder.StandardToStringStyle;
import org.apache.commons.lang.builder.ToStringBuilder;
import org.seasar.framework.container.annotation.tiger.Component;
import org.seasar.framework.container.annotation.tiger.InstanceType;
/**
 * アンケートForm
 *
 * @author choi-c
 *
 */
@Component(instance=InstanceType.SESSION)
public class EnqueteForm {
	
	//アンケートID
	public String eid;

	//アンケート
	public Enquete enquete;
	
	//設問マスタリスト
	public ArrayList<Question> questionList;
	
	/**アンケート通知メールからのキー*/
	public String qUrlId;
	/**
	 * PC=1,ケータイ=2,スマホ=3
	 */
	public String kind;
	
	/**
	 * 初期表示フラグ
	 */
	public String initCount;
	
	/**
	 * テンプレート
	 */
	public Template template;
	
	//リセットを処理するか0:処理しない、その他処理する。
	public String resetFlg;
	
	//アンケート回答完了メールのパラメータ(実際はmemberId)
	public String qid;
	
	//アンケート回答完了メールのパラメータ
	public String timeid;
	
	//1%支援制度ポイント寄付「select画面表示用」
	public List<Organization> organizationListFor1Percent;
	
	//回答確認画面で表示するため。
	public HashMap<String, String>  organizationMap;
	
	//プレビューの場合pre
	public String type;
	
	public Member member;

	//複数タブ表示不具合判定用
	public String chkeid = "";
	
	public void initReset(){
		type = null;
		kind = null;
		chkeid = "";
	}

	/**
	 * チェックボックスをリセットする。
	 */
	public void valueReset(){
		//チェックボックスをリセットする。
		if (questionList == null) {
			return;
		}
		for(Question question :questionList){
			for(Answer answer : question.answerList){
				
				if(question.controlId == SinaburoConstant.ControlType.CHECKBOX
						||  question.controlId == SinaburoConstant.ControlType.RADIO
						||  question.controlId == SinaburoConstant.ControlType.SELECTMENU){
					answer.answerIdValue = "";
				}
			}
		}
	}
	
	@Override
	public String toString() {
		return ToStringBuilder.reflectionToString(this, StandardToStringStyle.SIMPLE_STYLE).toString();
	}

}
