package jp.agentec.sinaburocast.service;

import java.util.List;

import org.seasar.extension.jdbc.where.SimpleWhere;
import org.seasar.framework.container.annotation.tiger.Component;
import org.seasar.framework.container.annotation.tiger.InstanceType;

import jp.agentec.sinaburocast.entity.Template;

@Component(instance=InstanceType.SINGLETON)
public class TemplateService extends AbstractService<Template> {

	
	
    public Template findById(Integer templateId) {
        return select().id(templateId).getSingleResult();
    }

    public List<Template> findAllOrderById() {
        return select().orderBy("template_id asc").getResultList();
    }
    
    
    public Template findByenqueteType(Integer enqueteType) {
        return select().where(new SimpleWhere().eq("enqueteType", enqueteType)).getSingleResult();
    }
}